--[[Author:		Cyprias 
	License:	All Rights Reserved
	Contact:	Cyprias on Curse.com or WowAce.com

	Only Curse.com and Wowace.com have permission to host this addon.
	I have not given permission for My Sales to be used in any addon compilation or UI pack.]]
-- globals
local GetInboxNumItems_ = GetInboxNumItems
local GetInboxHeaderInfo_ = GetInboxHeaderInfo
local GetInboxInvoiceInfo_ = GetInboxInvoiceInfo
local date_ = date
local table_getn = table.getn
local table_insert = table.insert
local InterfaceOptionsFrame_OpenToCategory_ = InterfaceOptionsFrame_OpenToCategory
local GetGuildRosterInfo_ = GetGuildRosterInfo

local folder, core = ...
MS = core --global

-- Metatable --
local _G = getfenv(0)
setmetatable(MS, {__index = _G})
setfenv(1, MS)
-- LOCAL --
title		= "My Sales"
version		= GetAddOnMetadata(folder, "X-Curse-Packaged-Version") or ""
titleFull	= title.." "..version

LibStub("AceAddon-3.0"):NewAddon(core, folder, "AceConsole-3.0", "AceSerializer-3.0", "AceHook-3.0", "AceEvent-3.0") 
local ScrollingTable = LibStub("ScrollingTable")
L = LibStub("AceLocale-3.0"):GetLocale(folder, true)

local regEvents = {
--~ 	"MAIL_SHOW",
--~ 	"MAIL_CLOSED",
	"GUILD_ROSTER_UPDATE",
	"FRIENDLIST_UPDATE",
	
}
P	= {} --db.profile
fR	= {} --db.factionrealm
db	= {}
defaultSettings	= {
	factionrealm = {
		sales = {},
		PoI = {},
	},
	profile = {},
}
guildMembers = {}
friendsList = {}

function core:OnInitialize()
	db = LibStub("AceDB-3.0"):New("MS_DB", defaultSettings)
	CoreOptionsTable.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(db)--save option profile or load another chars opts.
	db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	db.RegisterCallback(self, "OnProfileDeleted", "OnProfileChanged")
	self:RegisterChatCommand("ms", "MySlashProcessorFunc")
	
	
	local config = LibStub("AceConfig-3.0")
	local dialog = LibStub("AceConfigDialog-3.0")
	config:RegisterOptionsTable(title, CoreOptionsTable)
	coreOpts = dialog:AddToBlizOptions(title, titleFull)
end

function core:OnEnable()
--~ 	print(title, "OnEnable")
	P = db.profile
	fR = db.factionrealm
	
	self:Hook("TakeInboxMoney", true)
--~ 	self:Hook("TakeInboxItem", true)
	
	for i, event in pairs(regEvents) do 
		self:RegisterEvent(event)
	end
	
	BuildPoIList()
	
	core:FRIENDLIST_UPDATE("FRIENDLIST_UPDATE")
end

function core:OnDisable()
	
end


function core:GUILD_ROSTER_UPDATE(event, ...)
	guildMembers = {} --reset
	local numGuildMembers = GetNumGuildMembers(true)
	local name
	for i=1, numGuildMembers do 
		name = GetGuildRosterInfo_(i);
		guildMembers[name] = true
	end
end


function core:FRIENDLIST_UPDATE(event, ...)
	friendsList = {} --reset
	local numberOfFriends = GetNumFriends()
	local name
	for i=1, numberOfFriends do 
		 name = GetFriendInfo(i)
		 friendsList[name] = true
	end
end

local onlineColorTable = { ["r"] = 0.8, ["g"] = 0.8, ["b"] = 0.8, ["a"] = 1.0 }
function GetBuyerColour(data, cols, realrow, column, table)
	local buyerName = data[realrow].cols[column].value

	if guildMembers[buyerName] then
		return P.guildColour
	elseif friendsList[buyerName] then
		return P.friendColour
	elseif fR.PoI[buyerName] then
		return P.PoIColour
	end
	return onlineColorTable
end


----------------------------------------------------------------------
function core:OnProfileChanged(...)									--
-- User has reset proflie, so we reset our spell exists options.	--
----------------------------------------------------------------------
	-- Shut down anything left from previous settings
	self:Disable()
	-- Enable again with the new settings
	self:Enable()
end

----------------------------------------------
function core:MySlashProcessorFunc(input)	--
-- /da function brings up the UI options.	--
----------------------------------------------
--~ 	InterfaceOptionsFrame_OpenToCategory_(profitUI)--Expands the menu.
	InterfaceOptionsFrame_OpenToCategory_(coreOpts)
end

function core:TakeInboxItem(...)
	Debug("TakeInboxItem", ...)
end

function core:TakeInboxMoney(...)
	local mailIndex  = ...

	if GetInboxNumItems_() >= mailIndex then
		local _, _, sender, subject, money = GetInboxHeaderInfo_(mailIndex);
		local _, itemName, playerName = GetInboxInvoiceInfo_(mailIndex);


		if sender:find("Auction House") and subject:find("Auction successful:") then
--~ 			Debug("TakeInboxMoney", "mailIndex",mailIndex)
--~ 			Debug("TakeInboxMoney", "money",money)
--~ 			Debug("TakeInboxMoney", "itemName",itemName)
--~ 			Debug("TakeInboxMoney", "playerName",playerName)
--~ 			Debug("TakeInboxMoney", "",)
			
			if not playerName or playerName == "" then
				Debug("TakeInboxMoney", "No buyer", sender, subject, money, itemName, playerName)
			end
			
			local seral = self:Serialize(itemName, money, playerName, date_("%c"))
--~ 			Debug("TakeInboxMoney", "seral", seral)
			
			table_insert(fR.sales, #fR.sales+1, seral)
		end
	end
end

local listFrame

tableData = {}
function ShowWindow()--		/run MS.ShowWindow()
	if not listFrame then
		local AceGUI = LibStub("AceGUI-3.0")
		listFrame = listFrame or AceGUI:Create("Frame")
		local window = listFrame.frame;

		window:SetHeight(460);
		listFrame:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
		listFrame:SetTitle("My Sales")
		listFrame:SetStatusText("...")
		listFrame:SetLayout("Flow")

		local cols = {
			{ name= "Item", width = 200, defaultsort = "dsc", },
			{ name= "Money", width = 80, defaultsort = "dsc", 
				comparesort = function (self, rowa, rowb, sortbycol)
					if tableData[rowa] and tableData[rowb] then
						if self.cols[sortbycol].sort == "dsc" then
							return tableData[rowa].cols[sortbycol].args[1] < tableData[rowb].cols[sortbycol].args[1]
						else
							return tableData[rowa].cols[sortbycol].args[1] > tableData[rowb].cols[sortbycol].args[1]
						end
					end
				end,
			},
			{ name= "Buyer", width = 80, defaultsort = "dsc", },
			{ name= "When", width = 180, defaultsort = "dsc",
				comparesort = function (self, rowa, rowb, sortbycol)
					if tableData[rowa] and tableData[rowb] then
						if self.cols[sortbycol].sort == "dsc" then
							return tableData[rowa].cols[sortbycol].args[1] < tableData[rowb].cols[sortbycol].args[1]
						else
							return tableData[rowa].cols[sortbycol].args[1] > tableData[rowb].cols[sortbycol].args[1]
						end
					end
				end,
			},
		};
		
		local width = 0
		for i, data in pairs(cols) do 
			width = width + data.width
		end
		window:SetWidth(width);
		
		local st = ScrollingTable:CreateST(cols, 20, 16, nil, window)
		st.frame:SetPoint("BOTTOMLEFT",20,80)
		st.frame:SetPoint("TOP", window, 0, -45)
		st.frame:SetPoint("RIGHT", window, -20,0)
		listFrame.st = st
	end
	tableData = {}
	
	local success, who, data
	for i=1, table_getn(fR.sales) do 
		success, item, money, buyer, when = core:Deserialize(fR.sales[i])
		if success then
			table.insert(tableData, {
				cols = {
					{value = item},
					{
						value = function (copper)
							return CopperToCoins(copper)
						end,
						args = {money},
					},
					{value = buyer, color=GetBuyerColour},
					{
						value = function (secondsSince, when)
							if P.relativeWhen == true then
								return SecondsToString(secondsSince).." ago"
							else
								return when
							end
						end,
						args = {SecondsSinceDateString(when), when},
					},
				}
			})
		end
	end
	
	
	
	listFrame.st:SetData(tableData)
	listFrame.frame:Show()
end--	/run MS.ShowWindow()


 
